%{!?scl:%global pkg_name %{name}}
%{?scl:%scl_package rubygem-%{gem_name}}
%global gem_name openshift-origin-auth-mongo
%global rubyabi 1.9.1

Summary:       OpenShift plugin for mongo authentication service
Name:          rubygem-%{gem_name}
Version:       1.15.1.1
Release:       1%{?dist}
Group:         Development/Languages
License:       ASL 2.0
URL:           http://www.openshift.com
Source0:       http://mirror.openshift.com/pub/openshift-origin/source/%{name}/%{gem_name}-%{version}.gem
Source1:       favicon
%if 0%{?fedora} >= 19
Requires:      ruby(release)
%else
Requires:      %{?scl:%scl_prefix}ruby(abi) >= %{rubyabi}
%endif
Requires:      %{?scl:%scl_prefix}rubygems
Requires:      %{?scl:%scl_prefix}rubygem(activeresource)
Requires:      %{?scl:%scl_prefix}rubygem(json)
Requires:      rubygem(openshift-origin-common)
Requires:      rubygem(openshift-origin-controller)
Requires:      openshift-origin-broker
%if 0%{?fedora} >= 19
BuildRequires: ruby(release)
%else
BuildRequires: %{?scl:%scl_prefix}ruby(abi) >= %{rubyabi}
%endif
BuildRequires: %{?scl:%scl_prefix}rubygems-devel
BuildArch:     noarch
Provides:      rubygem(%{gem_name}) = %version

%description
Provides a mongo authentication service based plugin

%package doc
Summary:        OpenShift Origin mongodb docs

%description doc
OpenShift Origin mongodb authentication documentation files

%prep
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

%build
mkdir -p .%{gem_dir}

# Create the gem as gem install only works on a gem file
gem build %{gem_name}.gemspec

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
# gem install compiles any C extensions and installs into a directory
# We set that to be a local directory so that we can move it into the
# buildroot in %%install
gem install -V \
        --local \
        --install-dir .%{gem_dir} \
        --bindir ./%{_bindir} \
        --force \
        --rdoc \
        %{gem_name}-%{version}.gem

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/

# If there were programs installed:
mkdir -p %{buildroot}%{_bindir}
#cp -a ./%{_bindir}/* %{buildroot}%{_bindir}
cp -a bin/oo-register-user %{buildroot}%{_bindir}

mkdir -p %{buildroot}/etc/openshift/plugins.d
cp %{buildroot}/%{gem_instdir}/conf/openshift-origin-auth-mongo.conf.example %{buildroot}/etc/openshift/plugins.d/

# Clean up stuff
cp %{SOURCE1} %{buildroot}%{gem_instdir}/test/dummy/public/favicon.ico
rm -rf %{buildroot}%{gem_instdir}/.yardoc

%files
%doc LICENSE COPYRIGHT Gemfile
%exclude %{gem_cache}
%{gem_instdir}
%{gem_spec}
%{_bindir}/*
/etc/openshift/plugins.d/openshift-origin-auth-mongo.conf.example

%files doc
%doc %{gem_docdir}

%changelog
* Fri Dec 06 2013 Krishna Raman <kraman@gmail.com> 1.15.1.1-1
- Bumping versions for OpenShift Origin Release 3 (kraman@gmail.com)
- Add config value (jliggitt@redhat.com)
- Updating tests to register mongo-auth based user in the correct database
  based on Rails environment. (kraman@gmail.com)

* Wed Dec 04 2013 Krishna Raman <kraman@gmail.com> 1.15.1.1-1
- Add config value (jliggitt@redhat.com)
- Updating tests to register mongo-auth based user in the correct database
  based on Rails environment. (kraman@gmail.com)

* Fri Sep 13 2013 Troy Dawson <tdawson@redhat.com> 1.15.1-1
- Bump up version (tdawson@redhat.com)
- <broker> re-base the broker URI from /broker => / (lmeyer@redhat.com)
- Make set_log_tag lazy, so that all controllers have a default behavior Allow
  controllers to override log tag on their class, not on the instance Make
  allowances for legacy behavior (ccoleman@redhat.com)
- Avoid harmless but annoying deprecation warning (asari.ruby@gmail.com)

* Thu Aug 01 2013 Krishna Raman <kraman@gmail.com> 1.10.2.1-1
- Bumping version #s for origin release 2 (kraman@gmail.com)
- <broker> re-base the broker URI from /broker => / (lmeyer@redhat.com)
- Make set_log_tag lazy, so that all controllers have a default behavior Allow
  controllers to override log tag on their class, not on the instance Make
  allowances for legacy behavior (ccoleman@redhat.com)
- Avoid harmless but annoying deprecation warning (asari.ruby@gmail.com)

* Tue Jun 11 2013 Troy Dawson <tdawson@redhat.com> 1.10.2-1
- General REST API clean up - centralizing log tags and getting common objects
  (lnader@redhat.com)
- Bug 928675 (asari.ruby@gmail.com)

* Tue Jun 11 2013 Troy Dawson <tdawson@redhat.com> 1.10.1-1
- Bump up version to 1.10

* Sat Apr 13 2013 Krishna Raman <kraman@gmail.com> 1.5.2-1
- Read values from node.conf for origin testing. (rmillner@redhat.com)
- Updating rest-client and rake gem versions to match F18 (kraman@gmail.com)
- Merge pull request #1643 from kraman/update_parseconfig (dmcphers@redhat.com)
- Replacing get_value() with config['param'] style calls for new version of
  parseconfig gem. (kraman@gmail.com)
- Make packages build/install on F19+ (tdawson@redhat.com)
- remove old obsoletes (tdawson@redhat.com)

* Tue Mar 12 2013 Troy Dawson <tdawson@redhat.com> 1.5.1-2
- Change the source from a tar to gem

* Tue Mar 12 2013 Troy Dawson <tdawson@redhat.com> 1.5.1-1
- Implement authorization support in the broker (ccoleman@redhat.com)
- fix rubygem sources (tdawson@redhat.com)
- Fixes to get builds and tests running on RHEL: (kraman@gmail.com)
- Fixes for ruby193 (john@ibiblio.org)

* Tue Mar 12 2013 Troy Dawson <tdawson@redhat.com> 1.5.0-1
- Update to version 1.5.0

* Fri Feb 15 2013 Troy Dawson <tdawson@redhat.com> 1.4.1-2
- Change the source from a tar to gem

* Fri Feb 15 2013 Troy Dawson <tdawson@redhat.com> 1.4.1-1
- Add request id to mco requests (dmcphers@redhat.com)

* Fri Feb 15 2013 Troy Dawson <tdawson@redhat.com> 1.4.0-1
- Update to version 1.4.0

* Mon Feb 11 2013 Krishna Raman <kraman@gmail.com> 1.1.3-1
- Merge pull request #1289 from
  smarterclayton/isolate_api_behavior_from_base_controller
  (dmcphers+openshiftbot@redhat.com)
- Merge branch 'improve_action_logging' into
  isolate_api_behavior_from_base_controller (ccoleman@redhat.com)
- change %%define to %%global (tdawson@redhat.com)
- Reading hostname from node.conf file instead of relying on localhost
  Splitting test features into common, rhel only and fedora only sections
  (kraman@gmail.com)
- Fixing init-quota to allow for tabs in fstab file Added entries in abstract
  for php-5.4, perl-5.16 Updated python-2.6,php-5.3,perl-5.10 cart so that it
  wont build on F18 Fixed mongo broker auth Relaxed version requirements for
  acegi-security and commons-codec when generating hashed password for jenkins
  Added Apache 2.4 configs for console on F18 Added httpd 2.4 specific restart
  helper (kraman@gmail.com)
- remove BuildRoot: (tdawson@redhat.com)
- make Source line uniform among all spec files (tdawson@redhat.com)
- Remove legacy login() method on authservice (ccoleman@redhat.com)
- All controllers should inherit the standard filters, except where they are
  bypassed (ccoleman@redhat.com)

* Tue Jan 29 2013 Troy Dawson <tdawson@redhat.com> 1.1.2-2
- Change the source from a tar to gem

* Mon Jan 28 2013 Krishna Raman <kraman@gmail.com> 1.1.2-1
- 875575 (dmcphers@redhat.com)
- Fix mongo auth plugin (rpenta@redhat.com)
- Bug 890119 (lnader@redhat.com)
- Moving model refactor work - Updated cartridge manifest files - Simplified
  descriptor - Switched from mongo gem to use mongoid (kraman@gmail.com)
- Ensure write to at least 2 mongo instances (dmcphers@redhat.com)
- Adding support for broker to mongodb connections over SSL
  (calfonso@redhat.com)

* Tue Jan 15 2013 Troy Dawson <tdawson@redhat.com> 1.1.1-3
- copy over openshift-origin-auth-mongo.conf.example

* Tue Jan 15 2013 Troy Dawson <tdawson@redhat.com> 1.1.1-2
- Change the source from a tar to gem

* Fri Jan 11 2013 Troy Dawson <tdawson@redhat.com> 1.1.1-1
- updated gemspecs so they work with scl rpm spec files. (tdawson@redhat.com)
- more changes for US3078 (abhgupta@redhat.com)
- fix elif typos (dmcphers@redhat.com)
- add oo-ruby (dmcphers@redhat.com)
- more ruby1.9 changes (dmcphers@redhat.com)
- add config to gemspec (dmcphers@redhat.com)
- Moving plugins to Rails 3.2.8 engine (kraman@gmail.com)
- getting specs up to 1.9 sclized (dmcphers@redhat.com)
- specifying rake gem version range (abhgupta@redhat.com)
- Bug 871436 - moving the default path for AUTH_PRIVKEYFILE and AUTH_PUBKEYFILE
  under /etc (bleanhar@redhat.com)
- fix an ss reference (dmcphers@redhat.com)
- Moving broker config to /etc/openshift/broker.conf Rails app and all oo-*
  scripts will load production environment unless the
  /etc/openshift/development marker is present Added param to specify default
  when looking up a config value in OpenShift::Config Moved all defaults into
  plugin initializers instead of separate defaults file No longer require
  loading 'openshift-origin-common/config' if 'openshift-origin-common' is
  loaded openshift-origin-common selinux module is merged into F16 selinux
  policy. Removing from broker %%postrun (kraman@gmail.com)
- BZ847976 - Fixing Jenkins integration (bleanhar@redhat.com)
- Fixed broker/node setup scripts to install cgroup services. Fixed
  mcollective-qpid plugin so it installs during origin package build. Updated
  cgroups init script to work with both systemd and init.d Updated oo-trap-user
  script Renamed oo-cgroups to openshift-cgroups (service and init.d) and
  created oo-admin-ctl-cgroups Pulled in oo-get-mcs-level and abstract/util
  from origin-selinux branch Fixed invalid file path in rubygem-openshift-
  origin-auth-mongo spec Fixed invlaid use fo Mcollective::Config in
  mcollective-qpid-plugin (kraman@gmail.com)

* Thu Dec 06 2012 Troy Dawson <tdawson@redhat.com> -  0.8.9-2
- Update to version 0.8.9

* Thu Oct 11 2012 Brenton Leanhardt <bleanhar@redhat.com> 0.8.9-1
- fix for mongo auth plugin spec file (abhgupta@redhat.com)
- Centralize plug-in configuration (miciah.masters@gmail.com)
- Removing old build scripts Moving broker/node setup utilities into util
  packages Fix Auth service module name conflicts (kraman@gmail.com)
- Merge pull request #613 from kraman/master (openshift+bot@redhat.com)
- Module name and gem path fixes for auth plugins (kraman@gmail.com)

* Wed Aug 22 2012 Troy Dawson <tdawson@redhat.com> -  0.8.5-10
- Renamed library to correct name

* Thu Aug 09 2012 Adam Miller <admiller@redhat.com> - 0.8.5-9
- Removed dep on rubygem(mongo) as its not specifically needed
- Added rubygem(openshift-origin-controller), where the mongo tie in comes from
- Created doc subpackage

* Thu Aug 09 2012 Adam Miller <admiller@redhat.com> - 0.8.5-8
- Clean up old non-ruby package symlink for ruby_vendorlibdir

* Thu Aug 09 2012 Adam Miller <admiller@redhat.com> - 0.8.5-7
- No longer cleaning up false positive wrong-file-end-of-line-encoding 

* Tue Aug 07 2012 Adam Miller <admiller@redhat.com> - 0.8.5-6
- Removed non-gem sub-package, not needed by guidelines
- cleaned up wrong-file-end-of-line-encoding

* Thu Aug 02 2012 Troy Dawson <tdawson@redhat.com> - 0.8.5-5
- Added dependancies: rubygem(mongo) rubygem(activeresource)

* Tue Jul 24 2012 Troy Dawson <tdawson@redhat.com> 0.8.5-4
- Changed name to openshift-origin-auth-mongo
- Removed unessisary Requires and BuildRequires.

* Tue Jul 24 2012 Troy Dawson <tdawson@redhat.com> 0.8.5-3
- change ruby_sitelibdir to ruby_vendorlibdir per guidelines

* Fri Jul 20 2012 Troy Dawson <tdawson@redhat.com> 0.8.5-2
- Ported to be include in Fedora 18

* Wed May 30 2012 Krishna Raman <kraman@gmail.com> 0.8.5-1
- Fix for Bugz 825366, 825340. SELinux changes to allow access to
  user_action.log file. Logging authentication failures and user creation for
  OpenShift Origin (abhgupta@redhat.com)
- Raise auth exception when no user/password is provided by web browser. Bug
  815971 (kraman@gmail.com)
- Adding livecd build scripts Adding a text only minimal version of livecd
  Added ability to access livecd dns from outside VM (kraman@gmail.com)
- Merge pull request #19 from kraman/dev/kraman/bug/815971
  (dmcphers@redhat.com)
- Fix bug in mongo auth service where auth failure is returning nil instead of
  Exception (kraman@gmail.com)
- Adding a seperate message for errors returned by cartridge when trying to add
  them. Fixing CLIENT_RESULT error in node Removing tmp editor file
  (kraman@gmail.com)
- Added tests (kraman@gmail.com)
- BugZ# 817957. Adding rest api for creating a user in the mongo auth service.
  Rest API will be accessabel only from local host and will require login/pass
  of an existing user. (kraman@gmail.com)
- moving broker auth key and iv encoding/decoding both into the plugin
  (abhgupta@redhat.com)

* Thu Apr 26 2012 Krishna Raman <kraman@gmail.com> 0.8.4-1
- Added README for SwingShift-mongo plugin (rpenta@redhat.com)
- cleaning up spec files (dmcphers@redhat.com)
- decoding the broker auth key before returning from login in the auth plugin
  (abhgupta@redhat.com)

* Sat Apr 21 2012 Krishna Raman <kraman@gmail.com> 0.8.3-1
- new package built with tito
